/*******************************************************************************
* File Name: `$INSTANCE_NAME`.h
* Version `$CY_MAJOR_VERSION`.`$CY_MINOR_VERSION`
*
* Description:
*  This file provides constants and parameter values and API definition for the 
*  GraphicLCDIntf Component
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H

#include "cytypes.h"
#include "cyfitter.h"
#include "CyLib.h"
#include "cypins.h"    

/* Check to see if required defines such as CY_PSOC5LP are available */
/* They are defined starting with cy_boot v3.0 */
#ifndef CY_PSOC5LP
    #error Component `$CY_COMPONENT_NAME` requires cy_boot v3.0 or later
#endif /* CY_PSOCLP */


/*************************************** 
*   Conditional Compilation Parameters
***************************************/

#define `$INSTANCE_NAME`_BUS_WIDTH (`$BitWidth`u)


/***************************************
*        Structure Definitions
***************************************/

#if (CY_UDB_V0)
    /* Sleep Mode API Support */
    typedef struct _`$INSTANCE_NAME`_backupStruct
    {
        uint8 lowPulseWidth;
        uint8 highPulseWidth;
    } `$INSTANCE_NAME`_BACKUP_STRUCT;
#endif /* (CY_UDB_V0) */


/***************************************
*        Function Prototypes            
***************************************/

void `$INSTANCE_NAME`_Start(void)           `=ReentrantKeil($INSTANCE_NAME . "_Start")`;
void `$INSTANCE_NAME`_Stop(void)            `=ReentrantKeil($INSTANCE_NAME . "_Stop")`;
void `$INSTANCE_NAME`_Write`$BitWidthReplacementString`(uint8 d_c, `$DataTypeReplacementString` wrData) \
                                            `=ReentrantKeil($INSTANCE_NAME . "_Write`$BitWidthReplacementString`")`;
void `$INSTANCE_NAME`_WriteM`$BitWidthReplacementString`(uint8 d_c, `$DataTypeReplacementString`* wrData, uint16 num) \
                                            `=ReentrantKeil($INSTANCE_NAME . "_WriteM`$BitWidthReplacementString`")`;
`$DataTypeReplacementString` `$INSTANCE_NAME`_Read`$BitWidthReplacementString`(uint8 d_c) \
                                            `=ReentrantKeil($INSTANCE_NAME . "_Read`$BitWidthReplacementString`")`;

void `$INSTANCE_NAME`_Sleep(void)           `=ReentrantKeil($INSTANCE_NAME . "_Sleep")`;
void `$INSTANCE_NAME`_Wakeup(void)          `=ReentrantKeil($INSTANCE_NAME . "_Wakeup")`;
void `$INSTANCE_NAME`_SaveConfig(void)      `=ReentrantKeil($INSTANCE_NAME . "_SaveConfig")`;   
void `$INSTANCE_NAME`_RestoreConfig(void)   `=ReentrantKeil($INSTANCE_NAME . "_RestoreConfig")`;
void `$INSTANCE_NAME`_Init(void)            `=ReentrantKeil($INSTANCE_NAME . "_Init")`;
void `$INSTANCE_NAME`_Enable(void)          `=ReentrantKeil($INSTANCE_NAME . "_Enable")`;

#define CYGRAPHICS_START()                  `$INSTANCE_NAME`_Start()
#define CYGRAPHICS_STOP()                   `$INSTANCE_NAME`_Stop()
#define CYGRAPHICS_WRITE(addr, data)        `$INSTANCE_NAME`_Write`$BitWidthReplacementString`(addr, data)
#define CYGRAPHICS_READ(addr)               `$INSTANCE_NAME`_Read`$BitWidthReplacementString`(addr)
#define CYGRAPHICS_WRITEM(addr, data, num)  `$INSTANCE_NAME`_WriteM`$BitWidthReplacementString`(addr, data, num)


/***************************************
*        API Prototypes            
*        from TFT.h file
***************************************/
void `$INSTANCE_NAME`_Setup(uint8 orient);
void `$INSTANCE_NAME`_SetCol(uint16 StartCol,uint16 EndCol);
void `$INSTANCE_NAME`_SetRow(uint16 StartRow,uint16 EndRow);
void `$INSTANCE_NAME`_ClearScreen(uint16 bkColor);
void `$INSTANCE_NAME`_FillScreen(uint16 XL, uint16 XR, uint16 YU, uint16 YD, uint16 color);
void `$INSTANCE_NAME`_FillRectangle(uint16 poX, uint16 poY, uint16 length, uint16 width, uint16 color);
void `$INSTANCE_NAME`_DrawHorizontalLine( uint16 poX, uint16 poY, uint16 length,uint16 color);
void `$INSTANCE_NAME`_DrawLine( uint16 x0,uint16 y0,uint16 x1, uint16 y1,uint16 color);
void `$INSTANCE_NAME`_DrawVerticalLine( uint16 poX, uint16 poY, uint16 length,uint16 color);
void `$INSTANCE_NAME`_DrawRectangle(uint16 poX, uint16 poY, uint16 length, uint16 width,uint16 color);
void `$INSTANCE_NAME`_DrawCircle(int poX, int poY, int r,uint16 color);
void `$INSTANCE_NAME`_FillCircle(int poX, int poY, int r,uint16 color);
void `$INSTANCE_NAME`_SetOrientation(uint8 orient);
void `$INSTANCE_NAME`_DrawChar( uint8 ascii, uint16 poX, uint16 poY,uint16 size, uint16 fgcolor);
void `$INSTANCE_NAME`_DrawString(char *string,uint16 poX, uint16 poY, uint16 size,uint16 fgcolor);
void `$INSTANCE_NAME`_SetPixel(uint16 poX, uint16 poY,uint16 color);
void `$INSTANCE_NAME`_FillBitmap(uint16 poX, uint16 poY, uint16 length, uint16 width, unsigned short *Bitmap);
void `$INSTANCE_NAME`_Graf(uint16 XL, uint16 YU, uint16 YD, uint8  Ydata , uint8 last);
void `$INSTANCE_NAME`_Read_SD_Picture(uint16 XL, uint16 XR, uint16 YU, uint16 YD, unsigned short *FileName);

/***************************************
*        Internal Prototypes            
*        from TFT.h file
***************************************/
void `$INSTANCE_NAME`_WriteRegData(uint8 reg, uint16 data);
void `$INSTANCE_NAME`_WriteIndex(uint8 reg);
void `$INSTANCE_NAME`_WriteData(uint16 data);


/***************************************
*           API Constants               
***************************************/

#define `$INSTANCE_NAME`_CMD_QUEUE_FULL         (0x01u)
#define `$INSTANCE_NAME`_DATA_VALID             (0x02u)

#define `$INSTANCE_NAME`_READ_COMMAND           (0x02u)

#define `$INSTANCE_NAME`_DATA_ADDRESS           (0x01u)
#define `$INSTANCE_NAME`_COMMAND_ADDRESS        (0x00u)

/* from TFT.h file *******/

#define `$INSTANCE_NAME`_FONT_SPACE             10
#define `$INSTANCE_NAME`_FONT_X                 16
#define `$INSTANCE_NAME`_FONT_Y                 8

//Basic Colors
#define `$INSTANCE_NAME`_RED	 	            0xf800
#define `$INSTANCE_NAME`_GREEN	                0x07e0
#define `$INSTANCE_NAME`_BLUE	                0x001f
#define `$INSTANCE_NAME`_BLACK	                0x0000
#define `$INSTANCE_NAME`_YELLOW	                0xffe0
#define `$INSTANCE_NAME`_WHITE	                0xffff
#define `$INSTANCE_NAME`_CYAN		            0x07ff	
#define `$INSTANCE_NAME`_BRIGHT_RED	            0xf810	
#define `$INSTANCE_NAME`_GRAY1		            0x8410  
#define `$INSTANCE_NAME`_GRAY2		            0x4208  

#define `$INSTANCE_NAME`_MIN_X	                0
#define `$INSTANCE_NAME`_MIN_Y	                0


/***************************************
*    Enumerated Types and Parameters    
***************************************/


/***************************************
*    Initial Parameter Constants        
***************************************/

/* Set 2 less than period because di must be sampled one cycle before
*  the end of Read Low intervals.
*/ 
#define `$INSTANCE_NAME`_READ_LOW_PULSE           (`$ReadLoPulse`u - 2u)   

/* Set one less than period */ 
#define `$INSTANCE_NAME`_READ_HIGH_PULSE          (`$ReadHiPulse`u - 1u)


/***************************************
*             Registers                 
***************************************/

#define `$INSTANCE_NAME`_STATUS_REG                     (* (reg8 *)  `$INSTANCE_NAME`_StsReg__STATUS_REG)
#define `$INSTANCE_NAME`_STATUS_PTR                     (  (reg8 *)  `$INSTANCE_NAME`_StsReg__STATUS_REG)

#define `$INSTANCE_NAME`_DIN_LSB_DATA_REG               (* (reg8 *)  `$INSTANCE_NAME`_LsbReg__STATUS_REG)
#define `$INSTANCE_NAME`_DIN_LSB_DATA_PTR               (  (reg8 *)  `$INSTANCE_NAME`_LsbReg__STATUS_REG)

#if (`$INSTANCE_NAME`_BUS_WIDTH == 8u)   /* 8-bit interface */
    #define `$INSTANCE_NAME`_CMD_FIFO_REG               (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__F0_REG)
    #define `$INSTANCE_NAME`_CMD_FIFO_PTR               (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__F0_REG)
    #define `$INSTANCE_NAME`_DATA_FIFO_REG              (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__F1_REG)
    #define `$INSTANCE_NAME`_DATA_FIFO_PTR              (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__F1_REG)    
    #define `$INSTANCE_NAME`_READ_LO_PULSE_REG          (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__D0_REG)
    #define `$INSTANCE_NAME`_READ_LO_PULSE_PTR          (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__D0_REG)
    #define `$INSTANCE_NAME`_READ_HI_PULSE_REG          (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__D1_REG)
    #define `$INSTANCE_NAME`_READ_HI_PULSE_PTR          (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd8_Lsb__D1_REG)
#else   /* 16-bit interface */
    #define `$INSTANCE_NAME`_CMD_FIFO_REG               (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__F0_REG)
    #define `$INSTANCE_NAME`_CMD_FIFO_PTR               (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__F0_REG)
    #define `$INSTANCE_NAME`_DATA_FIFO_PTR              (  (reg16 *) `$INSTANCE_NAME`_GraphLcd16_Lsb__F1_REG)     
    #define `$INSTANCE_NAME`_DIN_MSB_DATA_REG           (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_MsbReg__STATUS_REG)
    #define `$INSTANCE_NAME`_DIN_MSB_DATA_PTR           (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_MsbReg__STATUS_REG)
    #define `$INSTANCE_NAME`_READ_LO_PULSE_REG          (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__D0_REG)
    #define `$INSTANCE_NAME`_READ_LO_PULSE_PTR          (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__D0_REG)
    #define `$INSTANCE_NAME`_READ_HI_PULSE_REG          (* (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__D1_REG)
    #define `$INSTANCE_NAME`_READ_HI_PULSE_PTR          (  (reg8 *)  `$INSTANCE_NAME`_GraphLcd16_Lsb__D1_REG) 
#endif /* `$INSTANCE_NAME`_BUS_WIDTH == 8u */

#endif /* CY_GraphicLCDIntf_`$INSTANCE_NAME`_H */


/* [] END OF FILE */
